///////////////////////////////////////////////////////////////////////////////////////////////////
//
// PROJECT : Arirang family
//
// DATE    : 2008.10.23
//
///////////////////////////////////////////////////////////////////////////////////////////////////
//
// FILE  : Arirang_4S8.h
//
// NOTES : Optimized code of Arirang family
// 
//         Based on 8-bit platform (4 8-bit S-box version)
//
///////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef __ARIRANG_4S8_H__
#define __ARIRANG_4S8_H__ 100

#include <stdlib.h>
#include "API_4S8.h"

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// Macro

// Define the Endianness
#undef BIG_ENDIAN
#undef LITTLE_ENDIAN

#if defined(USER_BIG_ENDIAN)
	#define BIG_ENDIAN
#elif defined(USER_LITTLE_ENDIAN)
	#define LITTLE_ENDIAN
#else
	#if 0
		#define BIG_ENDIAN
	#elif defined(_MSC_VER)
		#define LITTLE_ENDIAN
	#else
		#error
	#endif
#endif

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// Function

void gen_tabs(void);
void Arirang_Compression256(hashState *state);
void Arirang_Compression512(hashState *state);

#endif