///////////////////////////////////////////////////////////////////////////////////////////////////
//
// PROJECT : Arirang family
//
// DATE    : 2008.10.23
//
///////////////////////////////////////////////////////////////////////////////////////////////////
//
// FILE  : Arirang_1S8.h
//
// NOTES : Code of Arirang family
// 
//         Based on 8-bit platform (one S-box version)
//
///////////////////////////////////////////////////////////////////////////////////////////////////


#ifndef _ARIRNAG_1S8_H__
#define _ARIRANG_1S8_H__ 100

#include <stdlib.h>
#include "API_1S8.h"

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// Macro

// Define the Endianness
#undef BIG_ENDIAN
#undef LITTLE_ENDIAN

#if defined(USER_BIG_ENDIAN)
	#define BIG_ENDIAN
#elif defined(USER_LITTLE_ENDIAN)
	#define LITTLE_ENDIAN
#else
	#if 0
		#define BIG_ENDIAN
	#elif defined(_MSC_VER)
		#define LITTLE_ENDIAN
	#else
		#error
	#endif
#endif


///////////////////////////////////////////////////////////////////////////////////////////////////
//
// Function

void gen_tabs(void);
void Arirang_Compression256(hashState *state);
void Arirang_Compression512(hashState *state);


#endif